PreventMisclick_Options = {
};

PreventMisclick_Setup = {
	monitoredSpells = {};
	currentlyTargeting = nil;
	spellData = {};
	cachedActionIds = {};
};

function PreventMisclick_RemoveSpellData()
	PreventMisclick_Setup.currentlyTargeting = false;
	for k,v in PreventMisclick_Setup.spellData do
		PreventMisclick_Setup.spellData[k] = false;
	end
end


function PreventMisclick_ShowErrorMessage(msg)
	UIErrorsFrame:AddMessage(msg, 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
end


function PreventMisclick_LoadConstants()
	for k, v in PREVENTMISCLICK_OPTIONS_DEFAULT do
		if ( PreventMisclick_Options[k] == nil ) then
			PreventMisclick_Options[k] = v;
		end
	end
end

-- used when starting to cast spell - if false, will not allow spell to be cast on target
function PreventMisclick_StartCast(spellName, spellDataP1, spellDataP2)
	if ( not spellName ) then
		return false;
	end
	local tmp = spellName;
	local index = strfind(spellName, "%(");
	if ( index ) then
		spellDataP1 = spellName;
		spellName = strsub(spellName, 1, index-1);
	end
	if ( type(spellDataP1) == "number" ) and ( not spellDataP2 ) and ( GetActionText(spellDataP1) ) then 
		PreventMisclick_RemoveSpellData()
		return true; 
	end
	local realSpell = PREVENTMISCLICK_EQUAL_SPELLS[spellName];
	if ( realSpell ) then spellName = realSpell; end
	if ( PreventMisclick_Setup.monitoredSpells[spellName] ) then
		if ( not PreventMisclick_AllowUnit(spellName, "target") ) then
			return false;
		end
		PreventMisclick_RemoveSpellData()
		if ( type(spellDataP1) == "number" ) and ( type(spellDataP2) == "string" ) then
			PreventMisclick_Setup.spellData.castId = spellDataP1;
			PreventMisclick_Setup.spellData.castBook = spellDataP2;
		elseif ( type(spellDataP1) == "string" ) then
			PreventMisclick_Setup.spellData.cast = spellDataP1;
		elseif ( type(spellDataP1) == "number" ) then
			PreventMisclick_Setup.spellData.actionId = spellDataP1;
		end
		PreventMisclick_Setup.currentlyTargeting = spellName;
	end
	return true;
end

function PreventMisclick_AllowUnit(spellName, unit)
	if ( not spellName ) then return true; end
	if ( not UnitExists(unit) ) then return true; end
	if ( not PreventMisclick_Setup.monitoredSpells[spellName] ) then
		return true;
	end
	if ( not UnitIsFriend("player", unit) ) then
		return true;
	end
	if ( PreventMisclick_Options.alwaysAllowPlayer ) and ( UnitIsUnit(unit, "player") ) then
		return true;
	end
	local localizedClass, realClass = UnitClass(unit);
	if ( not PreventMisclick_AllowedClass(spellName, realClass, unit) ) then
		return false;
	end
	if ( not PreventMisclick_AllowedPowerType(spellName, UnitPowerType(unit)) ) then
		return false;
	end
	return true;
end

function PreventMisclick_IsElementInList(element, list)
	if ( list ) then
		for k, v in list do
			if ( v == element ) then
				return true;
			end
		end
	end
	return false;
end

function PreventMisclick_AllowedClass(spellName, realClass, unit)
	local arr = PREVENTMISCLICK_ALLOWED_CLASS[spellName];
	if ( arr ) then
		if ( PreventMisclick_IsElementInList(realClass, arr) ) then
			return true;
		end
		if ( unit ) then
			PreventMisclick_ShowErrorMessage(format(PREVENTMISCLICK_MSG_NOT_ALLOWED, spellName, UnitClass(unit)));
		end
		return false;
	end
	arr = PREVENTMISCLICK_DISALLOWED_CLASS[spellName];
	if ( arr ) then
		if ( PreventMisclick_IsElementInList(realClass, arr) ) then
			return false;
		end
		return true;
	end
	return true;
end

-- TODO: implement this
function PreventMisclick_AllowedPowerType(spellName, powerType)
	local arr = PREVENTMISCLICK_ALLOWED_POWERTYPE[spellName];
	if ( arr ) then
		if ( PreventMisclick_IsElementInList(realClass, arr) ) then
			return true;
		end
		if ( unit ) then
			PreventMisclick_ShowErrorMessage(format(PREVENTMISCLICK_MSG_NOT_ALLOWED, spellName, PREVENTMISCLICK_POWERTYPE[powerType]));
		end
		return false;
	end
	local arr = PREVENTMISCLICK_DISALLOWED_POWERTYPE[spellName];
	if ( arr ) then
		if ( PreventMisclick_IsElementInList(realClass, arr) ) then
			if ( unit ) then
				PreventMisclick_ShowErrorMessage(format(PREVENTMISCLICK_MSG_NOT_ALLOWED, spellName, PREVENTMISCLICK_POWERTYPE[powerType]));
			end
			return false;
		end
		return true;
	end
	return true;
end

function PreventMisclick_GetSpellNameFromActionId(id)
	local s = GetActionText(id);
	if ( s ) then return s; end
	local arr = PreventMisclick_Setup.cachedActionIds[id];
	if ( arr ) and ( arr.n ) then
		return arr.n;
	end
	local tooltip = PreventMisclickTooltip;
	local obj = getglobal(tooltip:GetName().."TextLeft1");
	tooltip:SetAction(id);
	local spellName = obj:GetText();
	arr = {};
	arr.n = spellName
	arr.t = GetActionTexture(id);
	PreventMisclick_Setup.cachedActionIds[id] = arr;
	return spellName;
end

PreventMisclick_LoadConstants();
