PreventMisclick_Hooks = {
	CastSpellByName = true;
	CastSpell = true;
	UseAction = true;
	SpellTargetUnit = true;
	SpellStopCasting = true;
	SpellStopTargeting = true;
};


function PreventMisclick_Hook()
	local src, target, saveName;
	for k, v in PreventMisclick_Hooks do
		src = getglobal(k);
		target = getglobal("PreventMisclick_"..k);
		saveName = "PreventMisclick_"..k.."_Saved";
		if ( src ~= target ) and ( not getglobal(saveName) ) then
			setglobal(saveName, src);
			setglobal(k, target);
		end
	end
	local oldH = nil;
	if ( PreventMisclick_WorldFrame_OnMouseDown ) then
		oldH = WorldFrame:GetScript("OnMouseDown");
		PreventMisclick_WorldFrame_OnMouseDown_Saved = oldH;
		WorldFrame:SetScript("OnMouseDown", PreventMisclick_WorldFrame_OnMouseDown);
	end
	if ( PreventMisclick_WorldFrame_OnMouseUp ) then
		oldH = WorldFrame:GetScript("OnMouseUp");
		PreventMisclick_WorldFrame_OnMouseUp_Saved = oldH;
		WorldFrame:SetScript("OnMouseUp", PreventMisclick_WorldFrame_OnMouseUp);
	end
end

function PreventMisclick_CastSpellByName(msg, p1, p2, p3)
	if ( not msg ) then
		return false;
	end
	if ( PreventMisclick_StartCast(msg, msg) ) then
		return PreventMisclick_CastSpellByName_Saved(msg, p1, p2, p3);
	else
		return false;
	end
end

function PreventMisclick_CastSpell(spell, spellBook, p1, p2, p3)
	local spellName = GetSpellName(spell, spellBook);
	if ( spellName ) and ( PreventMisclick_StartCast(spellName, spell, spellBook) ) then
		return PreventMisclick_CastSpell_Saved(spell, spellBook, p1, p2, p3);
	else
		return false;
	end
end

function PreventMisclick_UseAction(id, useSelf, p1, p2, p3)
	local spellName = PreventMisclick_GetSpellNameFromActionId(id);
	if ( GetActionText(id) ) or ( ( spellName ) and ( PreventMisclick_StartCast(spellName, spellName) ) )then
		return PreventMisclick_UseAction_Saved(id, useSelf, p1, p2, p3);
	else
		return false;
	end
end

function PreventMisclick_SpellTargetUnit(unit, p1, p2, p3)
	if ( PreventMisclick_AllowUnit(PreventMisclick_Setup.currentlyTargeting, unit) ) then
		return PreventMisclick_SpellTargetUnit_Saved(unit, p1, p2, p3);
	else
		return false;
	end
end

function PreventMisclick_SpellStopCasting(p1, p2, p3)
	PreventMisclick_RemoveSpellData();
	return PreventMisclick_SpellStopCasting_Saved(p1, p2, p3);
end

function PreventMisclick_SpellStopTargeting(p1, p2, p3)
	PreventMisclick_RemoveSpellData();
	return PreventMisclick_SpellStopTargeting_Saved(p1, p2, p3);
end


function PreventMisclick_WorldFrame_OnMouseDown(button, p2, p3)
	if ( button == "LeftButton" ) then
		local currentSpell = PreventMisclick_Setup.currentlyTargeting;
		if ( SpellIsTargeting() ) and ( SpellCanTargetUnit("mouseover") ) and ( currentSpell ) then
			if ( not PreventMisclick_AllowUnit(currentSpell, "mouseover") ) then
				SpellStopTargeting();
			else
				PreventMisclick_RemoveSpellData();
			end
		end
	end
	if ( PreventMisclick_WorldFrame_OnMouseDown_Saved ) then
		return PreventMisclick_WorldFrame_OnMouseDown_Saved(button, p2, p3);
	end
end

function PreventMisclick_WorldFrame_OnMouseDown2(button, p2, p3)
	if ( button == "LeftButton" ) then
		local currentSpell = PreventMisclick_Setup.currentlyTargeting;
		if ( SpellIsTargeting() ) and ( SpellCanTargetUnit("mouseover") ) and ( currentSpell ) then
			if ( not PreventMisclick_AllowUnit(currentSpell, "mouseover") ) then
				PreventMisclick_WorldFrame_Spell = currentSpell;
				SpellStopTargeting();
			end
		end
	end
	if ( PreventMisclick_WorldFrame_OnMouseDown_Saved ) then
		return PreventMisclick_WorldFrame_OnMouseDown_Saved(button, p2, p3);
	end
end

function PreventMisclick_WorldFrame_OnMouseUp2(button, p2, p3)
	if ( button == "LeftButton" ) then
		if ( PreventMisclick_WorldFrame_Spell ) then
			CastSpellByName(PreventMisclick_WorldFrame_Spell);
			PreventMisclick_WorldFrame_Spell = nil;
		end
	end
	if ( PreventMisclick_WorldFrame_OnMouseUp_Saved ) then
		return PreventMisclick_WorldFrame_OnMouseUp_Saved(button, p2, p3);
	end
end


function PreventMisclick_WorldFrame_OnMouseUp(button, p2, p3)
	if ( button == "RightButton" ) then
		local id, book = PreventMisclick_Setup.spellData.castId, PreventMisclick_Setup.spellData.castBook;
		if ( id ) and ( book ) then
			PreventMisclick_StartCast(GetSpellName(id, book), id, book);
			CastSpell(id, book);
		elseif ( PreventMisclick_Setup.spellData.cast ) then
			local s = PreventMisclick_Setup.spellData.cast;
			PreventMisclick_StartCast(s, s);
			CastSpellByName(s);
		elseif ( PreventMisclick_Setup.spellData.actionId ) then
			UseAction(PreventMisclick_Setup.spellData.actionId);
		end
	end
	if ( PreventMisclick_WorldFrame_OnMouseUp_Saved ) then
		return PreventMisclick_WorldFrame_OnMouseUp_Saved(button, p2, p3);
	end
end


